import { EventName, Options, ReactWebComponent } from '@lit/react';

type EventNames = Record<string, EventName | string>;
export type StencilReactComponent<I extends HTMLElement, E extends EventNames = {}> = ReactWebComponent<I, E>;
/**
 * Defines a custom element and creates a React component.
 * @public
 */
export declare const createComponent: <I extends HTMLElement, E extends EventNames = {}>({ defineCustomElement, ...options }: Options<I, E> & {
    defineCustomElement: () => void;
}) => ReactWebComponent<I, E>;
export {};
