import p from "react";
function P(e, n) {
  const r = RegExp(e, "g");
  return (t) => {
    if (typeof t != "string")
      throw new TypeError(`expected an argument of type string, but got ${typeof t}`);
    return t.match(r) ? t.replace(r, n) : t;
  };
}
const R = P(/[A-Z]/, (e) => `-${e.toLowerCase()}`);
function A(e, n = R) {
  if (!e || typeof e != "object" || Array.isArray(e))
    throw new TypeError(`expected an argument of type object, but got ${typeof e}`);
  return Object.keys(e).map((r) => `${n(r)}: ${e[r]};`).join(`
`);
}
const L = {
  acceptCharset: "accept-charset",
  accessKey: "accesskey",
  allowFullScreen: "allowfullscreen",
  autoCapitalize: "autocapitalize",
  autoComplete: "autocomplete",
  autoCorrect: "autocorrect",
  autoFocus: "autofocus",
  autoPlay: "autoplay",
  autoSave: "autosave",
  cellPadding: "cellpadding",
  cellSpacing: "cellspacing",
  charSet: "charset",
  className: "class",
  classID: "classid",
  colSpan: "colspan",
  contentEditable: "contenteditable",
  contextMenu: "contextmenu",
  controlsList: "controlslist",
  crossOrigin: "crossorigin",
  dangerouslySetInnerHTML: "dangerouslysetinnerhtml",
  dateTime: "datetime",
  defaultChecked: "defaultchecked",
  defaultValue: "defaultvalue",
  disablePictureInPicture: "disablepictureinpicture",
  disableRemotePlayback: "disableremoteplayback",
  encType: "enctype",
  enterKeyHint: "enterkeyhint",
  fetchPriority: "fetchpriority",
  htmlFor: "for",
  formMethod: "formmethod",
  formAction: "formaction",
  formEncType: "formenctype",
  formNoValidate: "formnovalidate",
  formTarget: "formtarget",
  frameBorder: "frameborder",
  hrefLang: "hreflang",
  httpEquiv: "http-equiv",
  imageSizes: "imagesizes",
  imageSrcSet: "imagesrcset",
  inputMode: "inputmode",
  itemID: "itemid",
  itemProp: "itemprop",
  itemRef: "itemref",
  itemScope: "itemscope",
  itemType: "itemtype",
  keyParams: "keyparams",
  keyType: "keytype",
  marginWidth: "marginwidth",
  marginHeight: "marginheight",
  maxLength: "maxlength",
  mediaGroup: "mediagroup",
  noModule: "nomodule",
  noValidate: "novalidate",
  playsInline: "playsinline",
  radioGroup: "radiogroup",
  readOnly: "readonly",
  referrerPolicy: "referrerpolicy",
  rowSpan: "rowspan",
  spellCheck: "spellcheck",
  srcDoc: "srcdoc",
  srcLang: "srclang",
  srcSet: "srcset",
  tabIndex: "tabindex",
  useMap: "usemap",
  accentHeight: "accent-height",
  alignmentBaseline: "alignment-baseline",
  arabicForm: "arabic-form",
  attributeName: "attributename",
  attributeType: "attributetype",
  autoReverse: "autoreverse",
  baseFrequency: "basefrequency",
  baselineShift: "baseline-shift",
  baseProfile: "baseprofile",
  calcMode: "calcmode",
  capHeight: "cap-height",
  clipPath: "clip-path",
  clipPathUnits: "clippathunits",
  clipRule: "clip-rule",
  colorInterpolation: "color-interpolation",
  colorInterpolationFilters: "color-interpolation-filters",
  colorProfile: "color-profile",
  colorRendering: "color-rendering",
  contentScriptType: "contentscripttype",
  contentStyleType: "contentstyletype",
  diffuseConstant: "diffuseconstant",
  dominantBaseline: "dominant-baseline",
  enableBackground: "enable-background",
  externalResourcesRequired: "externalresourcesrequired",
  fillOpacity: "fill-opacity",
  fillRule: "fill-rule",
  filterRes: "filterres",
  filterUnits: "filterunits",
  floodOpacity: "flood-opacity",
  floodColor: "flood-color",
  fontFamily: "font-family",
  fontSize: "font-size",
  fontSizeAdjust: "font-size-adjust",
  fontStretch: "font-stretch",
  fontStyle: "font-style",
  fontVariant: "font-variant",
  fontWeight: "font-weight",
  glyphName: "glyph-name",
  glyphOrientationHorizontal: "glyph-orientation-horizontal",
  glyphOrientationVertical: "glyph-orientation-vertical",
  gradientTransform: "gradienttransform",
  gradientUnits: "gradientunits",
  horizAdvX: "horiz-adv-x",
  horizOriginX: "horiz-origin-x",
  imageRendering: "image-rendering",
  kernelMatrix: "kernelmatrix",
  kernelUnitLength: "kernelunitlength",
  keyPoints: "keypoints",
  keySplines: "keysplines",
  keyTimes: "keytimes",
  lengthAdjust: "lengthadjust",
  letterSpacing: "letter-spacing",
  lightingColor: "lighting-color",
  limitingConeAngle: "limitingconeangle",
  markerEnd: "marker-end",
  markerHeight: "markerheight",
  markerMid: "marker-mid",
  markerStart: "marker-start",
  markerUnits: "markerunits",
  markerWidth: "markerwidth",
  maskContentUnits: "maskcontentunits",
  maskUnits: "maskunits",
  numOctaves: "numoctaves",
  overlinePosition: "overline-position",
  overlineThickness: "overline-thickness",
  paintOrder: "paint-order",
  panose1: "panose-1",
  pathLength: "pathlength",
  patternContentUnits: "patterncontentunits",
  patternTransform: "patterntransform",
  patternUnits: "patternunits",
  pointerEvents: "pointer-events",
  pointsAtX: "pointsatx",
  pointsAtY: "pointsaty",
  pointsAtZ: "pointsatz",
  preserveAlpha: "preservealpha",
  preserveAspectRatio: "preserveaspectratio",
  primitiveUnits: "primitiveunits",
  refX: "refx",
  refY: "refy",
  renderingIntent: "rendering-intent",
  repeatCount: "repeatcount",
  repeatDur: "repeatdur",
  requiredExtensions: "requiredextensions",
  requiredFeatures: "requiredfeatures",
  shapeRendering: "shape-rendering",
  slot: "slot",
  specularConstant: "specularconstant",
  specularExponent: "specularexponent",
  spreadMethod: "spreadmethod",
  startOffset: "startoffset",
  stdDeviation: "stddeviation",
  stitchTiles: "stitchtiles",
  stopColor: "stop-color",
  stopOpacity: "stop-opacity",
  strikethroughPosition: "strikethrough-position",
  strikethroughThickness: "strikethrough-thickness",
  strokeDasharray: "stroke-dasharray",
  strokeDashoffset: "stroke-dashoffset",
  strokeLinecap: "stroke-linecap",
  strokeLinejoin: "stroke-linejoin",
  strokeMiterlimit: "stroke-miterlimit",
  strokeWidth: "stroke-width",
  strokeOpacity: "stroke-opacity",
  suppressContentEditableWarning: "suppresscontenteditablewarning",
  suppressHydrationWarning: "suppresshydrationwarning",
  surfaceScale: "surfacescale",
  systemLanguage: "systemlanguage",
  tableValues: "tablevalues",
  targetX: "targetx",
  targetY: "targety",
  textAnchor: "text-anchor",
  textDecoration: "text-decoration",
  textLength: "textlength",
  textRendering: "text-rendering",
  transformOrigin: "transform-origin",
  underlinePosition: "underline-position",
  underlineThickness: "underline-thickness",
  unicodeBidi: "unicode-bidi",
  unicodeRange: "unicode-range",
  unitsPerEm: "units-per-em",
  vectorEffect: "vector-effect",
  vertAdvY: "vert-adv-y",
  vertOriginX: "vert-origin-x",
  vertOriginY: "vert-origin-y",
  wordSpacing: "word-spacing",
  writingMode: "writing-mode",
  xChannelSelector: "xchannelselector",
  xHeight: "x-height",
  xlinkActuate: "xlink:actuate",
  xlinkArcrole: "xlink:arcrole",
  xlinkHref: "xlink:href",
  xlinkRole: "xlink:role",
  xlinkShow: "xlink:show",
  xlinkTitle: "xlink:title",
  xlinkType: "xlink:type",
  xmlBase: "xml:base",
  xmlLang: "xml:lang",
  xmlnsXlink: "xmlns:xlink",
  yChannelSelector: "ychannelselector",
  zoomAndPan: "zoomandpan"
}, O = "[react-output-target]", m = (e) => typeof e == "string" || typeof e == "number" || typeof e == "boolean", u = (e) => e == null, x = (e) => Array.isArray(e), H = (e) => !!e && /^\s*class\s+/.test(e.toString()), $ = (e) => !!e && typeof e == "object" && "_payload" in e, j = (e) => async ({ children: n, ...r } = {}) => {
  if (!("process" in globalThis) || typeof window < "u")
    throw new Error("`createComponent` can only be run on the server");
  let t = "";
  for (const [i, o] of Object.entries(r)) {
    let s = m(o) ? `"${o}"` : void 0;
    if (i === "style" && typeof o == "object" && (s = `"${A.default(o).replaceAll(`
`, " ")}"`), !s)
      continue;
    const c = L[i] || e.properties[i] || i;
    t += ` ${c}=${s}`;
  }
  let a = "";
  const h = `<${e.tagName}${t} suppressHydrationWarning="true">`, S = console.error;
  try {
    process.env.STENCIL_SSR_DEBUG || (console.error = () => {
    });
    const i = await g(n), { renderToString: o } = await import("react-dom/server");
    a = o(i);
  } catch (i) {
    if (process.env.STENCIL_SSR_DEBUG) {
      const o = i instanceof Error ? i : new Error("Unknown error");
      console.warn(
        `${O} Failed to serialize light DOM for ${h.slice(0, -1)} />: ${o.message} - this may impact the hydration of the component`
      );
    }
  } finally {
    console.error = S;
  }
  const b = `${h}${a}</${e.tagName}>`, { html: d } = await e.renderToString(b, {
    fullDocument: !1,
    serializeShadowRoot: e.serializeShadowRoot ?? "declarative-shadow-dom",
    prettyHtml: !0
  });
  if (!d)
    throw new Error("No HTML returned from renderToString");
  const l = d.split(`
`), w = "<!--r.1-->", y = l[1].includes('shadowrootmode="open"');
  let k;
  y && (k = l.slice(2, l.indexOf("  </template>")).join(`
`).trim());
  const { default: v } = await import("html-react-parser"), C = v, T = () => C(d, {
    transform(i, o) {
      if ("name" in o && o.name === e.tagName) {
        const s = i.props, c = `${e.tagName}`;
        if (!y) {
          const { children: M, ...E } = s || {}, z = l.slice(1, -1).join(`
`).trim().replace(new RegExp("(?<=>)\\s+(?=<)", "g"), "");
          return /* @__PURE__ */ p.createElement(c, { ...E, suppressHydrationWarning: !0, dangerouslySetInnerHTML: { __html: z } });
        }
        return /* @__PURE__ */ p.createElement(c, { ...s, suppressHydrationWarning: !0 }, /* @__PURE__ */ p.createElement(
          "template",
          {
            shadowrootmode: "open",
            suppressHydrationWarning: !0,
            dangerouslySetInnerHTML: { __html: w + k }
          }
        ));
      }
    }
  });
  return /* @__PURE__ */ p.createElement(T, null);
};
async function g(e) {
  return m(e) || u(e) ? e : (x(e) || (e = [e]), Promise.all(
    Array.from(e).map(async (n) => {
      if (m(n) || u(n))
        return n;
      if (x(n))
        return g(n);
      const { type: r, props: t } = n;
      return {
        ...n,
        props: {
          ...t,
          children: await g(t.children)
        },
        type: await f(r, t)
      };
    })
  ));
}
const f = async (e, n) => {
  let r = null;
  if (typeof e == "string")
    return e;
  if (H(e)) {
    const t = new e(n);
    r = t.render ? t.render() : t;
  } else if ($(e)) {
    const t = e._payload, { deault: a } = t._status === -1 ? await t._result() : t._result;
    r = await f(a, n);
  } else typeof e != "object" && (r = await e(n));
  return !u(r) && !m(r) && "type" in r && (r = await f(r.type, n)), r;
}, _ = ({
  hydrateModule: e,
  properties: n,
  tagName: r,
  serializeShadowRoot: t
}) => async (a) => j({
  tagName: r,
  properties: n,
  renderToString: (await e).renderToString,
  serializeShadowRoot: t
})(a);
export {
  _ as createComponent
};
